function ClickListener( element, selector, style1, style2 ) {//background1, background2 ) {
    this.element = element;
    this.selector = selector;
//     this.bg1 = background1;
//     this.bg2 = background2;
    this.style_default = style1;
    this.style_activated = style2;

    this.isEnabled = true;

    this.flashInterval = 250;

    // methods
    this.click = _ClickListener__click;
    this.revert = _ClickListener__revert;
    this.enable = _ClickListener__enable;
    this.activate= _ClickListener__activate;

    // set default style
    this.element.setAttribute( 'class', this.style_default );

    // preload images
//     this.element.setAttribute( 'class', this.style_activated );
//     debug( "BACKGROUND_IMAGE : " + this.element.style.backgroundImage );
//     var image_url = this.element.style.backgroundImage;
//     if ( image_url ) {
//         var pos_p1 = image_url.toLowerCase().indexOf( "url(" );
//         var pos_p2 = image_url.lastIndexOf( ")" );
//         if ( pos_p1 < 0 ) pos_p1 = 0;
//         if ( pos_p2 < 0 ) pos_p2 = image_url.length;
//         var path_image = iamge_url.substring( pos_p1, pos_p2 );
//         var im = new Image();
//         im.src = path_image;
//         debug( path_image );
//     }
    

    var self = this;

    this.element.addEventListener( 'click', function() { self.click(); }, true );
}

function _ClickListener__click() {
    if ( this.isEnabled == false ) return;
    var localSelf = this;
    //debug( "click " + this.bg1 );
    setTimeout( function() { localSelf.revert(); }, this.flashInterval );
    this.element.setAttribute( 'class', this.style_activated );
    //this.element.style.background = this.bg1;
    setTimeout( function() { localSelf.selector(); }, 0 );
}

function _ClickListener__revert() {
    //debug( "click " + this.bg2 );
    //this.element.style.background = this.bg2;
    this.element.setAttribute( 'class', this.style_default );
}

function _ClickListener__enable( flag ) {
    this.isEnabled = flag;
}

function _ClickListener__activate( flag ) {
    if ( flag ) {
        this.element.setAttribute( 'class', this.style_activated );
    } else {
        this.element.setAttribute( 'class', this.style_default );
    }
}

